searchNodes=[{"doc":"General functions to work with JOSE","ref":"JOSEUtils.html","title":"JOSEUtils","type":"module"},{"doc":"Returns true if the string is an encrypted JWT, false otherwiseExampleiex&gt; jwe_token = &quot;eyJhbGciOiJBMTI4R0NNS1ciLCJlbmMiOiJBMTI4R0NNIiwiaXYiOiJzODNFNjhPNjhsWlM5ZVprIiwidGFnIjoieF9Ea2M5dm1LMk5RQV8tU2hvTkFRdyJ9.8B2qX8fVEa-s61RsZXqkCg.J7yJ8sKLbUlzyor6.FRs.BhBwImTv9B14NwVuxmfU6A&quot; &quot;eyJhbGciOiJBMTI4R0NNS1ciLCJlbmMiOiJBMTI4R0NNIiwiaXYiOiJzODNFNjhPNjhsWlM5ZVprIiwidGFnIjoieF9Ea2M5dm1LMk5RQV8tU2hvTkFRdyJ9.8B2qX8fVEa-s61RsZXqkCg.J7yJ8sKLbUlzyor6.FRs.BhBwImTv9B14NwVuxmfU6A&quot; iex&gt; JOSEUtils.is_jwe?(jwe_token) true iex&gt; jws_token = &quot;eyJhbGciOiJFZDI1NTE5In0.e30.xyg2LTblm75KbLFJtROZRhEgAFJdlqH9bhx8a9LO1yvLxNLhO9fLqnFuU3ojOdbObr8bsubPkPqUfZlPkGHXCQ&quot; &quot;eyJhbGciOiJFZDI1NTE5In0.e30.xyg2LTblm75KbLFJtROZRhEgAFJdlqH9bhx8a9LO1yvLxNLhO9fLqnFuU3ojOdbObr8bsubPkPqUfZlPkGHXCQ&quot; iex&gt; JOSEUtils.is_jwe?(jws_token) false","ref":"JOSEUtils.html#is_jwe?/1","title":"JOSEUtils.is_jwe?/1","type":"function"},{"doc":"Returns true if the string is an signed JWT, false otherwiseiex(2)&gt; JOSEUtils.is_jws?(&quot;eyJhbGciOiJIUzI1NiJ9.e30.5paAJxaOXSqRUIXrP_vJXUZu2SCBH-ojgP4D6Xr6GPU&quot;) true iex(3)&gt; JOSEUtils.is_jws?(&quot;Some.string&quot;) false","ref":"JOSEUtils.html#is_jws?/1","title":"JOSEUtils.is_jws?/1","type":"function"},{"doc":"Helper functions to work with JOSE algorithms","ref":"JOSEUtils.JWA.html","title":"JOSEUtils.JWA","type":"module"},{"doc":"Returns the JOSE algorithm from aan X509 signature algorithm, or nil if it has no JOSE equivalent","ref":"JOSEUtils.JWA.html#x509_to_jose_sig_alg/1","title":"JOSEUtils.JWA.x509_to_jose_sig_alg/1","type":"function"},{"doc":"Ec curveOne of:&quot;P-256&quot;&quot;P-384&quot;&quot;P-521&quot;&quot;Ed25519&quot;&quot;Ed448&quot;&quot;X25519&quot;&quot;X448&quot;&quot;secp256k1&quot;","ref":"JOSEUtils.JWA.html#t:crv/0","title":"JOSEUtils.JWA.crv/0","type":"type"},{"doc":"Algorithm (&quot;alg&quot;) used for encryptionOne of:&quot;A128GCMKW&quot;&quot;A128KW&quot;&quot;A192GCMKW&quot;&quot;A192KW&quot;&quot;A256GCMKW&quot;&quot;A256KW&quot;&quot;C20PKW&quot;&quot;ECDH-1PU&quot;&quot;ECDH-1PU+A128GCMKW&quot;&quot;ECDH-1PU+A128KW&quot;&quot;ECDH-1PU+A192GCMKW&quot;&quot;ECDH-1PU+A192KW&quot;&quot;ECDH-1PU+A256GCMKW&quot;&quot;ECDH-1PU+A256KW&quot;&quot;ECDH-1PU+C20PKW&quot;&quot;ECDH-ES&quot;&quot;ECDH-ES+A128GCMKW&quot;&quot;ECDH-ES+A128KW&quot;&quot;ECDH-ES+A192GCMKW&quot;&quot;ECDH-ES+A192KW&quot;&quot;ECDH-ES+A256GCMKW&quot;&quot;ECDH-ES+A256KW&quot;&quot;ECDH-ES+C20PKW&quot;&quot;PBES2-HS256+A128GCMKW&quot;&quot;PBES2-HS256+A128KW&quot;&quot;PBES2-HS384+A192GCMKW&quot;&quot;PBES2-HS384+A192KW&quot;&quot;PBES2-HS512+A256GCMKW&quot;&quot;PBES2-HS512+A256KW&quot;&quot;PBES2-HS512+C20PKW&quot;&quot;RSA-OAEP&quot;&quot;RSA-OAEP-256&quot;&quot;RSA1_5&quot;&quot;dir&quot;","ref":"JOSEUtils.JWA.html#t:enc_alg/0","title":"JOSEUtils.JWA.enc_alg/0","type":"type"},{"doc":"Encryption (&quot;enc&quot;) algorithm used for encryptionOne of:&quot;A128CBC-HS256&quot;&quot;A128GCM&quot;&quot;A192CBC-HS384&quot;&quot;A192GCM&quot;&quot;A256CBC-HS512&quot;,&quot;A256GCM&quot;&quot;C20P&quot;&quot;XC20P&quot;","ref":"JOSEUtils.JWA.html#t:enc_enc/0","title":"JOSEUtils.JWA.enc_enc/0","type":"type"},{"doc":"Signature algorithmOne of:&quot;EdDSA&quot;&quot;ES256&quot;&quot;ES384&quot;&quot;ES512&quot;&quot;HS256&quot;&quot;HS384&quot;&quot;HS512&quot;&quot;Poly1305&quot;&quot;PS256&quot;&quot;PS384&quot;&quot;PS512&quot;&quot;RS256&quot;&quot;RS384&quot;&quot;RS512&quot;&quot;none&quot;","ref":"JOSEUtils.JWA.html#t:sig_alg/0","title":"JOSEUtils.JWA.sig_alg/0","type":"type"},{"doc":"Convenience function to work with encrypted JWTs","ref":"JOSEUtils.JWE.html","title":"JOSEUtils.JWE","type":"module"},{"doc":"Decrypts a JWE encrypted token and returns the decryption keyIt filters the keys to select only those suitable for decryption, using JOSEUtils.JWKS.decryption_keys/3. If the JWE has an identifier (&quot;kid&quot;), it only uses that specific key.Exampleiex&gt; jwk_oct256 = JOSE.JWK.from_oct(&lt;&lt;0::256&gt;&gt;) iex&gt; jwk_oct256_map = JOSE.JWK.from_oct(&lt;&lt;0::256&gt;&gt;) |&gt; JOSE.JWK.to_map() |&gt; elem(1) iex&gt; encrypted_a256gcmkw = JOSE.JWE.block_encrypt(jwk_oct256, &quot;{}&quot;, %{ &quot;alg&quot; =&gt; &quot;A256GCMKW&quot;, &quot;enc&quot; =&gt; &quot;A256GCM&quot; }) |&gt; JOSE.JWE.compact |&gt; elem(1) iex&gt; JOSEUtils.JWE.decrypt(encrypted_a256gcmkw, jwk_oct256_map, [&quot;A256KW&quot;], [&quot;A256GCM&quot;]) :error iex&gt; JOSEUtils.JWE.decrypt(encrypted_a256gcmkw, jwk_oct256_map, [&quot;A256KW&quot;, &quot;A256GCMKW&quot;], [&quot;A256GCM&quot;]) {:ok, {&quot;{}&quot;, %{&quot;kty&quot; =&gt; &quot;oct&quot;}}}","ref":"JOSEUtils.JWE.html#decrypt/4","title":"JOSEUtils.JWE.decrypt/4","type":"function"},{"doc":"Encrypts a payload with a JWK given an key derivation algorithm and an encryption algorithmThe payload can be a string, in which case it is signed directly, or any other data type which will first be converted into text using JSON serialization.If the JWK has a key id (&quot;kid&quot; member), it is automatically added to the resulting JWS.","ref":"JOSEUtils.JWE.html#encrypt/5","title":"JOSEUtils.JWE.encrypt/5","type":"function"},{"doc":"","ref":"JOSEUtils.JWE.html#encrypt!/5","title":"JOSEUtils.JWE.encrypt!/5","type":"function"},{"doc":"Returns the JOSE algorithm name from a %JOSE.JWE{} structureiex&gt; jwk_oct128 = JOSE.JWK.from_oct(&lt;&lt;0::128&gt;&gt;) iex&gt; encrypted_a128gcmkw = JOSE.JWE.block_encrypt(jwk_oct128, &quot;{}&quot;, %{ &quot;alg&quot; =&gt; &quot;A128GCMKW&quot;, &quot;enc&quot; =&gt; &quot;A128GCM&quot; }) |&gt; JOSE.JWE.compact |&gt; elem(1) iex&gt; JOSE.JWE.block_decrypt(jwk_oct128, encrypted_a128gcmkw) |&gt; elem(1) |&gt; JOSEUtils.JWE.jose_alg() &quot;A128GCMKW&quot;","ref":"JOSEUtils.JWE.html#jose_alg/1","title":"JOSEUtils.JWE.jose_alg/1","type":"function"},{"doc":"Returns the JOSE encryption algorithm name from a %JOSE.JWE{} structure","ref":"JOSEUtils.JWE.html#jose_enc/1","title":"JOSEUtils.JWE.jose_enc/1","type":"function"},{"doc":"Returns the unverified headerIt ensures that the &quot;alg&quot; and &quot;enc&quot; mandatory parameters are present.Examplesiex&gt; JOSEUtils.JWE.peek_header(&quot;eyJhbGciOiJkaXIiLCJlbmMiOiJBMTI4Q0JDLUhTMjU2In0..jBt5tTa1Q0N3uFPEkf30MQ.Ei49MvTLLje7bsZ5EZCZMA.gMWOAmhZSq9ksHCZm6VSoA&quot;) {:ok, %{&quot;alg&quot; =&gt; &quot;dir&quot;, &quot;enc&quot; =&gt; &quot;A128CBC-HS256&quot;}} iex&gt; JOSEUtils.JWE.peek_header(&quot;this is obviously invalid&quot;) {:error, %JOSEUtils.JWE.MalformedError{message: &quot;malformed JWE&quot;}}","ref":"JOSEUtils.JWE.html#peek_header/1","title":"JOSEUtils.JWE.peek_header/1","type":"function"},{"doc":"Serialized JWE encrypted tokenFor instance:&quot;eyJhbGciOiJBMTI4R0NNS1ciLCJlbmMiOiJBMTI4R0NNIiwiaXYiOiJzODNFNjhPNjhsWlM5ZVprIiwidGFnIjoieF9Ea2M5dm1LMk5RQV8tU2hvTkFRdyJ9.8B2qX8fVEa-s61RsZXqkCg.J7yJ8sKLbUlzyor6.FRs.BhBwImTv9B14NwVuxmfU6A&quot;","ref":"JOSEUtils.JWE.html#t:serialized/0","title":"JOSEUtils.JWE.serialized/0","type":"type"},{"doc":"Convenience functions to work with JWKs","ref":"JOSEUtils.JWK.html","title":"JOSEUtils.JWK","type":"module"},{"doc":"Returns the list of supported key derivation algorithm for a given JWKExamplesiex&gt; JOSE.JWK.generate_key({:rsa, 2048}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.enc_algs_supported() [&quot;RSA1_5&quot;, &quot;RSA-OAEP&quot;, &quot;RSA-OAEP-256&quot;] iex&gt; JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.enc_algs_supported() [&quot;ECDH-ES&quot;, &quot;ECDH-ES+A128KW&quot;, &quot;ECDH-ES+A192KW&quot;, &quot;ECDH-ES+A256KW&quot;] iex&gt; JOSE.JWK.generate_key({:oct, 16}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.enc_algs_supported() [&quot;A128KW&quot;, &quot;A128GCMKW&quot;, &quot;dir&quot;, &quot;PBES2-HS256+A128KW&quot;, &quot;PBES2-HS384+A192KW&quot;, &quot;PBES2-HS512+A256KW&quot;] iex&gt; JOSE.JWK.generate_key({:oct, 32}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.enc_algs_supported() [&quot;A256KW&quot;, &quot;A256GCMKW&quot;, &quot;dir&quot;, &quot;PBES2-HS256+A128KW&quot;, &quot;PBES2-HS384+A192KW&quot;, &quot;PBES2-HS512+A256KW&quot;] iex&gt; JOSE.crypto_fallback(true) iex&gt; JOSE.JWK.generate_key({:okp, :Ed25519}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.enc_algs_supported() [&quot;ECDH-ES&quot;, &quot;ECDH-ES+A128KW&quot;, &quot;ECDH-ES+A192KW&quot;, &quot;ECDH-ES+A256KW&quot;]","ref":"JOSEUtils.JWK.html#enc_algs_supported/1","title":"JOSEUtils.JWK.enc_algs_supported/1","type":"function"},{"doc":"Returns the key type for an algorithm or nil for the &quot;none&quot; and &quot;dir&quot; algorithmsExampleiex&gt; JOSEUtils.JWK.key_type_for_alg(&quot;RS512&quot;) &quot;RSA&quot; iex&gt; JOSEUtils.JWK.key_type_for_alg(&quot;ECDH-ES+A128KW&quot;) &quot;EC&quot; iex&gt; JOSEUtils.JWK.key_type_for_alg(&quot;dir&quot;) nil","ref":"JOSEUtils.JWK.html#key_type_for_alg/1","title":"JOSEUtils.JWK.key_type_for_alg/1","type":"function"},{"doc":"Returns true if the key conforms to the key selector specification, false otherwiseExamplesiex&gt; JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; Map.put(:fields, %{&quot;kid&quot; =&gt; &quot;key_id&quot;}) |&gt; JOSE.JWK.to_map |&gt; elem(1) |&gt; JOSEUtils.JWK.match_key_selector?([]) true iex&gt; JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; Map.put(:fields, %{&quot;kid&quot; =&gt; &quot;key_id&quot;}) |&gt; JOSE.JWK.to_map |&gt; elem(1) |&gt; JOSEUtils.JWK.match_key_selector?([kid: &quot;abc&quot;]) false iex&gt; JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; Map.put(:fields, %{&quot;kid&quot; =&gt; &quot;key_id&quot;}) |&gt; JOSE.JWK.to_map |&gt; elem(1) |&gt; JOSEUtils.JWK.match_key_selector?([kty: &quot;EC&quot;]) true iex&gt; JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; Map.put(:fields, %{&quot;kid&quot; =&gt; &quot;key_id&quot;}) |&gt; JOSE.JWK.to_map |&gt; elem(1) |&gt; JOSEUtils.JWK.match_key_selector?([kty: &quot;RSA&quot;]) false iex&gt; JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; Map.put(:fields, %{&quot;kid&quot; =&gt; &quot;key_id&quot;}) |&gt; JOSE.JWK.to_map |&gt; elem(1) |&gt; JOSEUtils.JWK.match_key_selector?([use: &quot;sig&quot;]) true iex&gt; JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; Map.put(:fields, %{&quot;kid&quot; =&gt; &quot;key_id&quot;}) |&gt; JOSE.JWK.to_map |&gt; elem(1) |&gt; JOSEUtils.JWK.match_key_selector?([use: &quot;enc&quot;]) true iex&gt; JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; Map.put(:fields, %{&quot;kid&quot; =&gt; &quot;key_id&quot;}) |&gt; JOSE.JWK.to_map |&gt; elem(1) |&gt; JOSEUtils.JWK.match_key_selector?([key_ops: &quot;a&quot;]) true iex&gt; JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; Map.put(:fields, %{&quot;kid&quot; =&gt; &quot;key_id&quot;}) |&gt; JOSE.JWK.to_map |&gt; elem(1) |&gt; JOSEUtils.JWK.match_key_selector?([key_ops: &quot;sign&quot;]) true iex&gt; JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; Map.put(:fields, %{&quot;kid&quot; =&gt; &quot;key_id&quot;}) |&gt; JOSE.JWK.to_map |&gt; elem(1) |&gt; JOSEUtils.JWK.match_key_selector?([alg: [&quot;ES256&quot;, &quot;ES512&quot;]]) true iex&gt; JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; Map.put(:fields, %{&quot;alg&quot; =&gt; &quot;ES384&quot;}) |&gt; JOSE.JWK.to_map |&gt; elem(1) |&gt; JOSEUtils.JWK.match_key_selector?([alg: [&quot;ES256&quot;, &quot;ES512&quot;]]) false","ref":"JOSEUtils.JWK.html#match_key_selector?/2","title":"JOSEUtils.JWK.match_key_selector?/2","type":"function"},{"doc":"Returns the digest used by a signature algorithm of the key","ref":"JOSEUtils.JWK.html#sig_alg_digest/1","title":"JOSEUtils.JWK.sig_alg_digest/1","type":"function"},{"doc":"Returns the list of supported signature algorithms for a given JWKExampleiex&gt; JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.sig_algs_supported() [&quot;ES256&quot;] iex&gt; JOSE.JWK.generate_key({:ec, &quot;P-521&quot;}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.sig_algs_supported() [&quot;ES512&quot;] iex&gt; JOSE.JWK.generate_key({:oct, 32}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.sig_algs_supported() [&quot;HS256&quot;] iex&gt; JOSE.JWK.generate_key({:oct, 48}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.sig_algs_supported() [&quot;HS256&quot;, &quot;HS384&quot;] iex&gt; JOSE.JWK.generate_key({:oct, 47}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.sig_algs_supported() [&quot;HS256&quot;] iex&gt; JOSE.JWK.generate_key({:oct, 64}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.sig_algs_supported() [&quot;HS256&quot;, &quot;HS384&quot;, &quot;HS512&quot;] iex&gt; JOSE.JWK.generate_key({:rsa,2048}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.sig_algs_supported() [&quot;RS256&quot;, &quot;RS384&quot;, &quot;RS512&quot;, &quot;PS256&quot;, &quot;PS384&quot;, &quot;PS512&quot;] iex&gt; JOSE.crypto_fallback(true) iex&gt; JOSE.JWK.generate_key({:okp, :Ed25519}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.sig_algs_supported() [&quot;EdDSA&quot;]","ref":"JOSEUtils.JWK.html#sig_algs_supported/1","title":"JOSEUtils.JWK.sig_algs_supported/1","type":"function"},{"doc":"Returns the public key from a private keyFor &quot;oct&quot; symmetrical keys, it returns all fields except the &quot;k&quot; private secret. It is recommended to have the &quot;kid&quot; attribute set in this case, otherwise the key is indistinguishable from other similar symmetrical keys.Examplesiex&gt; match?(%{&quot;kty&quot; =&gt; &quot;EC&quot;, &quot;crv&quot; =&gt; &quot;P-521&quot;}, JOSE.JWK.generate_key({:ec, &quot;P-521&quot;}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.to_public()) true iex&gt; JOSE.JWK.generate_key({:oct, 32}) |&gt; JOSE.JWK.to_map() |&gt; elem(1) |&gt; JOSEUtils.JWK.to_public() %{&quot;kty&quot; =&gt; &quot;oct&quot;}","ref":"JOSEUtils.JWK.html#to_public/1","title":"JOSEUtils.JWK.to_public/1","type":"function"},{"doc":"Verifies a JWKIt performs the following checks:verifies that the &quot;x5c&quot; member (if present) against:the JWK keythe &quot;alg&quot; memberthe &quot;use&quot; memberthe &quot;key_ops&quot; memberthe &quot;x5t&quot; member, if presentthe &quot;x5t#S256&quot; member, if presentvalidates the certificate chainverifies that the &quot;use&quot; and &quot;key_ops&quot; members are consistentverifies that the &quot;key_ops&quot; operations are related to each other","ref":"JOSEUtils.JWK.html#verify/1","title":"JOSEUtils.JWK.verify/1","type":"function"},{"doc":"","ref":"JOSEUtils.JWK.html#t:certificate/0","title":"JOSEUtils.JWK.certificate/0","type":"type"},{"doc":"","ref":"JOSEUtils.JWK.html#t:key_op/0","title":"JOSEUtils.JWK.key_op/0","type":"type"},{"doc":"","ref":"JOSEUtils.JWK.html#t:key_selector/0","title":"JOSEUtils.JWK.key_selector/0","type":"type"},{"doc":"","ref":"JOSEUtils.JWK.html#t:key_selector_opt/0","title":"JOSEUtils.JWK.key_selector_opt/0","type":"type"},{"doc":"","ref":"JOSEUtils.JWK.html#t:kid/0","title":"JOSEUtils.JWK.kid/0","type":"type"},{"doc":"","ref":"JOSEUtils.JWK.html#t:kty/0","title":"JOSEUtils.JWK.kty/0","type":"type"},{"doc":"","ref":"JOSEUtils.JWK.html#t:result/0","title":"JOSEUtils.JWK.result/0","type":"type"},{"doc":"A JSON Web Key in its map formFor instance:%{ &quot;crv&quot; =&gt; &quot;P-256&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;x&quot; =&gt; &quot;6pwDpICQ8JBWdvuLuXeWILAxSEUNB_BBAswikgYKKmY&quot;, &quot;y&quot; =&gt; &quot;fEHj1ehsIJ7PP-qon-oONl_J2yZLWpUncNRedZT7xqs&quot; }","ref":"JOSEUtils.JWK.html#t:t/0","title":"JOSEUtils.JWK.t/0","type":"type"},{"doc":"","ref":"JOSEUtils.JWK.html#t:use/0","title":"JOSEUtils.JWK.use/0","type":"type"},{"doc":"Convenience function to work with JWK sets","ref":"JOSEUtils.JWKS.html","title":"JOSEUtils.JWKS","type":"module"},{"doc":"Returns the keys suitable for decryption from a JWK set","ref":"JOSEUtils.JWKS.html#decryption_keys/3","title":"JOSEUtils.JWKS.decryption_keys/3","type":"function"},{"doc":"Returns the keys suitable for encryption from a JWK set","ref":"JOSEUtils.JWKS.html#encryption_keys/3","title":"JOSEUtils.JWKS.encryption_keys/3","type":"function"},{"doc":"Filters the JWKS using a key selector t:JWK.key_selector/0","ref":"JOSEUtils.JWKS.html#filter/2","title":"JOSEUtils.JWKS.filter/2","type":"function"},{"doc":"Returns the keys suitable for signature from a JWK setNote that it does not return the keys suitable only for signature verification.MAC keys are considered signature keys, and are returned as well.","ref":"JOSEUtils.JWKS.html#signature_keys/2","title":"JOSEUtils.JWKS.signature_keys/2","type":"function"},{"doc":"Returns the keys suitable for signature verification from a JWK setMAC keys are considered verification keys, and are returned as well.","ref":"JOSEUtils.JWKS.html#verification_keys/2","title":"JOSEUtils.JWKS.verification_keys/2","type":"function"},{"doc":"","ref":"JOSEUtils.JWKS.html#t:t/0","title":"JOSEUtils.JWKS.t/0","type":"type"},{"doc":"Convenience functions to work with signed JWTs","ref":"JOSEUtils.JWS.html","title":"JOSEUtils.JWS","type":"module"},{"doc":"Returns the unverified headerIt ensures the &quot;alg&quot; parameter is set.Exampleiex&gt; JOSEUtils.JWS.peek_header(&quot;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.e30.dMAojPMVbFvvkouYUSI9AxIRBxgqretQMCvNF7KmTHU&quot;) {:ok, %{&quot;alg&quot; =&gt; &quot;HS256&quot;, &quot;typ&quot; =&gt; &quot;JWT&quot;}} iex&gt; JOSEUtils.JWS.peek_header(&quot;probably invalid...?&quot;) {:error, %JOSEUtils.JWS.MalformedError{message: &quot;malformed JWS&quot;}}","ref":"JOSEUtils.JWS.html#peek_header/1","title":"JOSEUtils.JWS.peek_header/1","type":"function"},{"doc":"Returns :mac if the JWS uses a MAC signature algoithm, :public_key_crypto otherwiseExampleiex&gt; JOSE.JWS.sign(JOSE.JWK.generate_key({:ec, &quot;P-256&quot;}), &quot;toto&quot;, %{&quot;alg&quot; =&gt; &quot;ES256&quot;}) ...&gt; |&gt; JOSE.JWS.compact() ...&gt; |&gt; elem(1) ...&gt; |&gt; JOSEUtils.JWS.sig_alg_type() :public_key_crypto iex&gt; JOSE.JWS.sign(JOSE.JWK.generate_key({:oct, 32}), &quot;toto&quot;, %{&quot;alg&quot; =&gt; &quot;HS256&quot;}) ...&gt; |&gt; JOSE.JWS.compact() ...&gt; |&gt; elem(1) ...&gt; |&gt; JOSEUtils.JWS.sig_alg_type() :mac","ref":"JOSEUtils.JWS.html#sig_alg_type/1","title":"JOSEUtils.JWS.sig_alg_type/1","type":"function"},{"doc":"Signs a payload with a JWK and a given signing algorithmThe payload can be a string, in which case it is signed directly, or any other data type which will first be converted into text using JSON serialization.If the JWK has a key id (&quot;kid&quot; member), it is automatically added to the resulting JWS.When using the &quot;none&quot; algorithm, anything can be passed as the JWK (as it is not used).Exampleiex&gt; jwk = %{&quot;k&quot; =&gt; &quot;FWTNVgrQyQyZmduoAVyOfI1myMs&quot;, &quot;kty&quot; =&gt; &quot;oct&quot;} iex&gt; JOSEUtils.JWS.sign(&quot;some text&quot;, jwk, &quot;HS256&quot;) {:ok, &quot;eyJhbGciOiJIUzI1NiJ9.c29tZSB0ZXh0.2L2wNRpAOw92LSAII2PQ9_y9zi2YD9NfjJuGBpNkVBE&quot;} iex&gt; JOSE.unsecured_signing(true) iex&gt; JOSEUtils.JWS.sign!(&quot;test payload&quot;, %{}, &quot;none&quot;, %{&quot;some&quot; =&gt; &quot;header&quot;}) &quot;eyJhbGciOiJub25lIiwic29tZSI6ImhlYWRlciJ9.dGVzdCBwYXlsb2Fk.&quot;","ref":"JOSEUtils.JWS.html#sign/4","title":"JOSEUtils.JWS.sign/4","type":"function"},{"doc":"See sign/4","ref":"JOSEUtils.JWS.html#sign!/4","title":"JOSEUtils.JWS.sign!/4","type":"function"},{"doc":"Verifies the signature of a JWS, and returns its content and the signature keyThe function also filters the key using JOSEUtils.JWKS.verification_keys/2 with the whitelisted signature algorithms. If the JWS has an identifier (&quot;kid&quot;), it only uses that specific key.Exampleiex&gt; JOSE.crypto_fallback(true) iex&gt; jwk_ed25519 = JOSE.JWK.generate_key({:okp, :Ed25519}) iex&gt; jwk_ed25519_map = jwk_ed25519 |&gt; JOSE.JWK.to_map() |&gt; elem(1) iex&gt; signed_ed25519 = JOSE.JWS.sign(jwk_ed25519, &quot;{}&quot;, %{ &quot;alg&quot; =&gt; &quot;EdDSA&quot; }) |&gt; JOSE.JWS.compact |&gt; elem(1) iex&gt; JOSEUtils.JWS.verify(signed_ed25519, jwk_ed25519_map, [&quot;RS256&quot;]) :error iex&gt; JOSEUtils.JWS.verify(signed_ed25519, jwk_ed25519_map, [&quot;EdDSA&quot;]) |&gt; elem(0) :ok","ref":"JOSEUtils.JWS.html#verify/3","title":"JOSEUtils.JWS.verify/3","type":"function"},{"doc":"Serialized JWS signed tokenFor instance:&quot;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiIxMjM0NTY3ODkwIiwibmFtZSI6IkpvaG4gRG9lIiwiaWF0IjoxNTE2MjM5MDIyfQ.SflKxwRJSMeKKF2QT4fwpMeJf36POk6yJV_adQssw5c&quot;","ref":"JOSEUtils.JWS.html#t:serialized/0","title":"JOSEUtils.JWS.serialized/0","type":"type"},{"doc":"","ref":"JOSEUtils.JWE.MalformedError.html","title":"JOSEUtils.JWE.MalformedError","type":"exception"},{"doc":"","ref":"JOSEUtils.JWS.MalformedError.html","title":"JOSEUtils.JWS.MalformedError","type":"exception"},{"doc":"JOSEUtilsConvenience functions to work with JOSE (JSON Object Signing and Encryption)","ref":"readme.html","title":"JOSEUtils","type":"extras"},{"doc":"def deps do [ {:jose_utils, &quot;~&gt; 0.4.0&quot;} ] end","ref":"readme.html#installation","title":"JOSEUtils - Installation","type":"extras"}]